import { PING, PONG } from './config';
export function effectorMiddleware() {
  var config = {
    plain: new Map()
  };
  return next => action => {
    if (typeof action === 'object' && action != null && typeof action.type === 'string') {
      if (action.type === PING) {
        return {
          type: PONG,
          payload: config
        };
      }

      var handler = config.plain.get(action.type);

      if (typeof action.send === 'function') {
        action.send(next);
        return action;
      }

      if (handler && action.meta == null) {
        handler(action.payload);
        return action;
      }

      var result = next(action);
      return result;
    }

    return next(action);
  };
}
//# sourceMappingURL=middleware.js.map