"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.effectorMiddleware = effectorMiddleware;

var _config = require("./config");

function effectorMiddleware() {
  var config = {
    plain: new Map()
  };
  return next => action => {
    if (typeof action === 'object' && action != null && typeof action.type === 'string') {
      if (action.type === _config.PING) {
        return {
          type: _config.PONG,
          payload: config
        };
      }

      var handler = config.plain.get(action.type);

      if (typeof action.send === 'function') {
        action.send(next);
        return action;
      }

      if (handler && action.meta == null) {
        handler(action.payload);
        return action;
      }

      var result = next(action);
      return result;
    }

    return next(action);
  };
}
//# sourceMappingURL=middleware.js.map