"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.safeDispatch = safeDispatch;
exports.port = port;

// import {type Subject, async as subject} from 'most-subject'
function safeDispatch(data, dispatch) {
  if (typeof data === 'object' && data != null && typeof data.type === 'string') {
    dispatch(data);
  }
}

function port(dispatch, state$, action$) {
  return function epic(handler) {
    var result = handler(action$, state$).multicast();
    result.observe(data => safeDispatch(data, dispatch));
    return result;
  };
}
//# sourceMappingURL=port.js.map